ROUND equ 8
CATMULL_SHIFT equ 8

;----Procedure draws gouraud triangle with z coordinate -
;----interpolation ( Catmull alghoritm )-----------------
;----First stage of proc - see 3grd_tex.inc file --------

;----------------- procedure don't save registers !!-----
gouraud_line_z:
;----------------- procedure drawing smooth shaded-------
;----------------- horizontal line with z ---------------
;----------------- coordinate interpolation -------------

;in:
; xm0 - b1 g1 r1 z1 as dword integer
; xm2 - b2 g2 r2 z2 as dword integer
; xm4 - lo -> hi = tx1, ty1, tx2, ty2 as dword int
; eax - x1, ebx - x2, stack other params

;---------------------- .z_buffer - pointer to Z-buffer--
;---------------------- Z-buffer filled with dd variables
;---------------------- shifted CATMULL_SHIFT------------
;----------------- stack:

.y_max	  equ [ebp+24]
.y_min	  equ [ebp+22]
.tex_ptr  equ [ebp+18]
.screen   equ [ebp+14]
.z_buffer equ [ebp+10]
.y	  equ [ebp+8]


.x1	equ [ebp-2]
.x2	equ [ebp-4]

.z2	equ [ebp-8]
.r2	equ [ebp-12]
.g2	equ [ebp-16]
.b2	equ [ebp-20]

.z1	equ [ebp-24]
.r1	equ [ebp-28]
.g1	equ [ebp-32]
.b1	equ [ebp-36]

.dz	equ dword[ebp-40]
.dc_r	equ [ebp-44]
.dc_g	equ dword[ebp-48]
.dc_b	equ [ebp-52]


	push	 ebp
	mov	 ebp,esp

	mov	 dx,.y
	cmp	 dx,.y_min
	jl	 .gl_quit
	cmp	 dx,.y_max
	jge	 .gl_quit

	cmp	 eax,ebx
	je	 .gl_quit
	jl	 @f
	movaps	 xmm1,xmm0
	movaps	 xmm0,xmm2
	movaps	 xmm2,xmm1
	xchg	 eax,ebx
   @@:


	mov	 dx,[xres_var]
	cmp	 ax,dx
	jge	 .gl_quit
	cmp	 bx,0
	jle	 .gl_quit

	push	 ax
	push	 bx
	sub	 esp,50
	movups	 .b1,xmm0
	movups	 .b2,xmm2

	sub	 ebx,eax
	cvtsi2ss xmm4,ebx
	shufps	 xmm4,xmm4,0
	rcpps	 xmm4,xmm4
	psubd	 xmm2,xmm0
	cvtdq2ps xmm2,xmm2
	mulps	 xmm2,xmm4
	cvtps2dq xmm3,xmm2

	cmp	 word .x1,0	; clipping on function
	jg	 @f
	movsx	 ebx,word .x1
	neg	 ebx
	cvtsi2ss xmm5,ebx
	shufps	 xmm5,xmm5,0
	mulps	 xmm5,xmm2
	cvtps2dq xmm3,xmm5
      @@:
	mov	ax,[xres_var]
	cmp	word .x2,ax
	jl	@f
	mov	word .x2,ax
     @@:
	movups	 .dc_b,xmm3
     ;	 sub	 esp,8		; calculate memory begin
	movzx	edx,[xres_var] ; in buffers
	movzx	eax, word .y
	mul	edx
	movzx	edx, word .x1
	add	eax,edx
	shl	eax,2
	mov	edi,eax
	xchg	esi,eax
	add	esi,.z_buffer
	add	edi,.screen
	mov	cx,word .x2
	sub	cx,word .x1
	movzx	ecx,cx

      pxor	xmm3,xmm3
      mov	ebx,.z1  ; ebx -> cur z
      movups	xmm1,.b1
      movups	xmm2,.dc_b

   .ddraw:
     cmp	ebx,dword[esi]
     jge	@f
     mov	dword[esi],ebx
     movdqa	xmm0,xmm1
     psrld	xmm0,ROUND
     pshufd	xmm0,xmm0,11000110b
     packssdw	xmm0,xmm0
     packuswb	xmm0,xmm0
     movd	[edi],xmm0
   @@:
     add	esi,4
     add	edi,4
     add	ebx,.dz
     paddd	xmm1,xmm2
     loop	.ddraw


   .gl_quit:

     mov       esp,ebp
     pop       ebp
ret 18

